package com.tourism.webadmin.back.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.tourism.webadmin.back.service.*;
import com.tourism.webadmin.back.dao.*;
import com.tourism.webadmin.back.model.*;
import com.tourism.common.core.base.dao.BaseDaoMapper;
import com.tourism.common.core.constant.GlobalDeletedFlag;
import com.tourism.common.core.object.MyRelationParam;
import com.tourism.common.core.object.CallResult;
import com.tourism.common.core.base.service.BaseService;
import com.tourism.common.core.util.MyModelUtil;
import com.tourism.common.sequence.wrapper.IdGeneratorWrapper;
import com.github.pagehelper.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * 旅游项目管理数据操作服务类。
 *
 * @author 吃饭睡觉
 * @date 2024-09-06
 */
@Slf4j
@Service("tourismProjectService")
public class TourismProjectServiceImpl extends BaseService<TourismProject, Long> implements TourismProjectService {

    @Autowired
    private IdGeneratorWrapper idGenerator;
    @Autowired
    private TourismProjectMapper tourismProjectMapper;
    @Autowired
    private DirectoryInfoService directoryInfoService;
    @Autowired
    private TourismFileService tourismFileService;
    @Autowired
    private TourismContentService tourismContentService;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<TourismProject> mapper() {
        return tourismProjectMapper;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public TourismProject saveNew(TourismProject tourismProject) {
        tourismProjectMapper.insert(this.buildDefaultValue(tourismProject));
        return tourismProject;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<TourismProject> tourismProjectList) {
        if (CollUtil.isNotEmpty(tourismProjectList)) {
            tourismProjectList.forEach(this::buildDefaultValue);
            tourismProjectMapper.insertList(tourismProjectList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<TourismProject> tourismProjectList, int batchSize) {
        if (CollUtil.isEmpty(tourismProjectList)) {
            return;
        }
        if (batchSize <= 0) {
            batchSize = 10000;
        }
        int start = 0;
        do {
            int end = Math.min(tourismProjectList.size(), start + batchSize);
            List<TourismProject> subList = tourismProjectList.subList(start, end);
            // 如果数据量过大，同时当前表中存在createTime或updateTime等字段，可以考虑在外部创建一次 new Date()，
            // 然后传入buildDefaultValue，这样可以减少对象的创建次数，降低GC，提升效率。橙单之所以没有这样生成，是因为
            // 有些业务场景下需要按照这两个日期字段排序，因此我们只是在这里给出优化建议。
            subList.forEach(this::buildDefaultValue);
            tourismProjectMapper.insertList(subList);
            if (end == tourismProjectList.size()) {
                break;
            }
            start += batchSize;
        } while (true);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public TourismProject saveNewWithRelation(TourismProject tourismProject, JSONObject relationData) {
        this.saveNew(tourismProject);
        this.saveOrUpdateOneToOneRelationData(tourismProject, relationData);
        return tourismProject;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(TourismProject tourismProject, TourismProject originalTourismProject) {
        MyModelUtil.fillCommonsForUpdate(tourismProject, originalTourismProject);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<TourismProject> uw = this.createUpdateQueryForNullValue(tourismProject, tourismProject.getId());
        return tourismProjectMapper.update(tourismProject, uw) == 1;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean updateWithRelation(
            TourismProject tourismProject, TourismProject originalTourismProject, JSONObject relationData) {
        // tourismProject 为空的时候，无需修改主表数据。
        if (tourismProject != null && !this.update(tourismProject, originalTourismProject)) {
            return false;
        }
        this.saveOrUpdateOneToOneRelationData(originalTourismProject, relationData);
        return true;
    }

    private void saveOrUpdateOneToOneRelationData(TourismProject tourismProject, JSONObject relationData) {
        // 对于一对一新增或更新，如果主键值为空就新增，否则就更新，同时更新updateTime和updateUserId。
        TourismFile tourismFile = relationData.getObject("tourismFile", TourismFile.class);
        if (tourismFile != null) {
            tourismFile.setAssociationTableId(tourismProject.getId());
            tourismFileService.saveNewOrUpdate(tourismFile,
                    tourismFileService::saveNew, tourismFileService::update);
        }
        TourismContent tourismContent = relationData.getObject("tourismContent", TourismContent.class);
        if (tourismContent != null) {
            tourismContent.setAssociationId(tourismProject.getId());
            tourismContentService.saveNewOrUpdate(tourismContent,
                    tourismContentService::saveNew, tourismContentService::update);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long id) {
        if (tourismProjectMapper.deleteById(id) == 0) {
            return false;
        }
        tourismFileService.removeByAssociationTableId(id);
        tourismContentService.removeByAssociationId(id);
        return true;
    }

    @Override
    public List<TourismProject> getTourismProjectList(TourismProject filter, String orderBy) {
        return tourismProjectMapper.getTourismProjectList(filter, orderBy);
    }

    @Override
    public List<TourismProject> getTourismProjectListWithRelation(TourismProject filter, String orderBy) {
        List<TourismProject> resultList = tourismProjectMapper.getTourismProjectList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    @Override
    public CallResult verifyImportList(List<TourismProject> dataList, Set<String> ignoreFieldSet) {
        CallResult callResult;
        if (!CollUtil.contains(ignoreFieldSet, "isHotspot")) {
            callResult = verifyImportForConstDict(dataList, "isHotspotDictMap", TourismProject::getIsHotspot);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "enable")) {
            callResult = verifyImportForConstDict(dataList, "enableDictMap", TourismProject::getEnable);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "belongTab")) {
            callResult = verifyImportForDatasourceDict(dataList, "belongTabDictMap", TourismProject::getBelongTab);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "id")) {
            callResult = verifyImportForOneToOneRelation(dataList, "TourismFile", TourismProject::getId);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        return CallResult.ok();
    }

    @Override
    public CallResult verifyRelatedData(TourismProject tourismProject, TourismProject originalTourismProject) {
        String errorMessageFormat = "数据验证失败，关联的%s并不存在，请刷新后重试！";
        //这里是基于字典的验证。
        if (this.needToVerify(tourismProject, originalTourismProject, TourismProject::getBelongTab)
                && !directoryInfoService.existId(tourismProject.getBelongTab())) {
            return CallResult.error(String.format(errorMessageFormat, "所属分类"));
        }
        return CallResult.ok();
    }

    private TourismProject buildDefaultValue(TourismProject tourismProject) {
        if (tourismProject.getId() == null) {
            tourismProject.setId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(tourismProject);
        tourismProject.setDataState(GlobalDeletedFlag.NORMAL);
        return tourismProject;
    }
}
